package sample;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

import fi.jyu.mit.Music.*;


/**
 * Testiohjelma. Dokumentoi!
 * @author Antoine Kalmbach
 */
@SuppressWarnings("unused")
public class PlaySample {
    /**
     * @param args ei kytss
     */
    public static void main(String[] args) {
//        MidiPlayer mp = new MidiPlayer();
//        mp.setVerbose(true);
//        mp.play("ASDF");
     //   concurrentSample();
     //   midiFileSample();
          ukkoNoaSample();   
          
    }
    
    private static void ukkoNoaSample() {
        BufferedMidiPlayer2 mp = new BufferedMidiPlayer2();
        mp.setTempo(150);
        mp.play("CCCEDDDFEEDDC*");
        mp.play("EEEEG*F*DDDDF*E*");
        mp.play("CCCEDDDFEEDDC*");
        mp.run();
    }

    private static void midiFileSample() {
        MidiPlayer ss = new MidiPlayer();
        ss.setVerbose(true);
        //ss.playMidiFile("sw1end.mid");
        ss.playMidiFile("ukkonooa.mid");
    }
    
    private static void outl(String msg) {
        System.out.println(msg);
    }
    
    private static void out(String msg) {
        System.out.print(msg + " ");
    }
    
    private static void concurrentSample() {
        ThreadedMidiPlayer css = new ThreadedMidiPlayer();
        css.setVerbose(true);
        css.begin();
        css.play("CEG-EBbC-AC#E", 0.25, 5);
        css.play("-EBbC-");
        try {
            Thread.sleep(2500);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
        css.end();
    }
    
    // TODO siirr SoundSystem-luokan metodiksi
    private static void keyboardSample() {
        MidiPlayer ss = new MidiPlayer(true);
        ss.setVerbose(true);
        ss.setInstrument(1);
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        String line = "";
        try {
            while ((line = br.readLine()) != null) {
                ss.play(line);
            }
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
        
    private static void ascFileSample() {
        MidiPlayer ss = new MidiPlayer();
        ss.setVerbose(true);
        ss.setInstrument(1);
        ss.playAsciiFile("testSong.asc");
//        ss.playSingleNote("C", 1, 5);
//        ss.play("C#5C5GBbC5E5G");
//        ss.playSingleNote("Bb", 1.0);
//        ss.play("Bb");
//        ss.play("CC#CC#C", 0.25, 5);
//        ss.play("BG");
//        ss.playSingleNote("Bb", 1.0);
//        ss.play("Bb");
//        ss.play("C5");
//        ss.play("BBbAG#GF#");
//        ss.playSingleNote("F", 1.0);
    }
    
    private static void asyncSample() {
        BufferedMidiPlayer ss = new BufferedMidiPlayer();

        ss.setVerbose(true);
        ss.setInstrument(1);
        ss.play("BbADEFG");
        ss.playSingleNote("C", 1, 5);
        ss.play("C#C", 5);
        ss.play("GBb");
        ss.play("C", 5);
        ss.play("E", 5);
        ss.playSingleNote("G");
        ss.playSingleNote("Bb", 1.0);
        ss.play("Bb");
        ss.play("CC#CC#C", 5);
        ss.play("BG");
        ss.playSingleNote("Bb", 1.0);
        ss.play("Bb");
        ss.play("C", 5);
        ss.play("BBbAG#GF#");
        ss.playSingleNote("F", 1.0);
        ss.runAsync();
        System.out.println("Asynkronista soittoa! Odotetaan kymmenen sekuntia...");
        try {
            Thread.sleep(10000);
            ss.stop();
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }
}
